'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _isClass = require('is-class');

var _isClass2 = _interopRequireDefault(_isClass);

var _reactRedux = require('react-redux');

var _createFieldProps = require('./createFieldProps');

var _createFieldProps2 = _interopRequireDefault(_createFieldProps);

var _bindActionData = require('./bindActionData');

var _bindActionData2 = _interopRequireDefault(_bindActionData);

var _deepEqual = require('deep-equal');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var createConnectedField = function createConnectedField(_ref, getIn, name) {
  var asyncValidate = _ref.asyncValidate;
  var blur = _ref.blur;
  var change = _ref.change;
  var focus = _ref.focus;
  var getFormState = _ref.getFormState;
  var initialValues = _ref.initialValues;

  var ConnectedField = function (_Component) {
    _inherits(ConnectedField, _Component);

    function ConnectedField(props, context) {
      _classCallCheck(this, ConnectedField);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ConnectedField).call(this, props, context));

      if (!context._reduxForm) {
        throw new Error('ConnectedField must be inside a component decorated with reduxForm()');
      }
      _this.isValid = _this.isValid.bind(_this);
      return _this;
    }

    _createClass(ConnectedField, [{
      key: 'shouldComponentUpdate',
      value: function shouldComponentUpdate(nextProps) {
        return !(0, _deepEqual2.default)(this.props, nextProps);
      }
    }, {
      key: 'isValid',
      value: function isValid() {
        var _props = this.props;
        var syncError = _props.syncError;
        var asyncError = _props.asyncError;
        var submitError = _props.submitError;

        var error = syncError || asyncError || submitError;
        return !error;
      }
    }, {
      key: 'render',
      value: function render() {
        var _props2 = this.props;
        var component = _props2.component;
        var defaultValue = _props2.defaultValue;

        var props = _objectWithoutProperties(_props2, ['component', 'defaultValue']);

        var factory = (0, _isClass2.default)(component) ? _react2.default.createFactory(component) : component;
        return factory((0, _createFieldProps2.default)(getIn, name, props, initialValues && getIn(initialValues, name), defaultValue, asyncValidate));
      }
    }]);

    return ConnectedField;
  }(_react.Component);

  ConnectedField.propTypes = {
    component: _react.PropTypes.func.isRequired,
    defaultValue: _react.PropTypes.any
  };

  ConnectedField.contextTypes = {
    _reduxForm: _react.PropTypes.object
  };

  var actions = (0, _bindActionData2.default)({ blur: blur, change: change, focus: focus }, { field: name });
  var connector = (0, _reactRedux.connect)(function (state, ownProps) {
    return {
      initial: getIn(getFormState(state), 'initial.' + name),
      value: getIn(getFormState(state), 'values.' + name),
      state: getIn(getFormState(state), 'fields.' + name),
      syncError: getIn(getFormState(state), 'syncErrors.' + name),
      asyncError: getIn(getFormState(state), 'asyncErrors.' + name),
      submitError: getIn(getFormState(state), 'submitErrors.' + name),
      submitFailed: getIn(getFormState(state), 'submitFailed'),
      _value: ownProps.value // save value passed in (for checkboxes)
    };
  }, actions, undefined, { withRef: true });
  return connector(ConnectedField);
};

exports.default = createConnectedField;