'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createOnBlur = require('./events/createOnBlur');

var _createOnBlur2 = _interopRequireDefault(_createOnBlur);

var _createOnChange = require('./events/createOnChange');

var _createOnChange2 = _interopRequireDefault(_createOnChange);

var _createOnDragStart = require('./events/createOnDragStart');

var _createOnDragStart2 = _interopRequireDefault(_createOnDragStart);

var _createOnDrop = require('./events/createOnDrop');

var _createOnDrop2 = _interopRequireDefault(_createOnDrop);

var _createOnFocus = require('./events/createOnFocus');

var _createOnFocus2 = _interopRequireDefault(_createOnFocus);

var _lodash = require('lodash.partial');

var _lodash2 = _interopRequireDefault(_lodash);

var _lodash3 = require('lodash.noop');

var _lodash4 = _interopRequireDefault(_lodash3);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var processProps = function processProps(props, _value) {
  var type = props.type;
  var value = props.value;

  var rest = _objectWithoutProperties(props, ['type', 'value']);

  if (type === 'checkbox') {
    return _extends({}, rest, {
      checked: !!value,
      type: type
    });
  }
  if (type === 'radio') {
    return _extends({}, rest, {
      checked: value === _value,
      type: type,
      value: _value
    });
  }
  return props;
};

var createFieldProps = function createFieldProps(getIn, name, _ref, initialPropValue) {
  var asyncError = _ref.asyncError;
  var blur = _ref.blur;
  var change = _ref.change;
  var focus = _ref.focus;
  var initial = _ref.initial;
  var mapProps = _ref.mapProps;
  var state = _ref.state;
  var submitError = _ref.submitError;
  var submitFailed = _ref.submitFailed;
  var syncError = _ref.syncError;
  var value = _ref.value;
  var _value = _ref._value;

  var rest = _objectWithoutProperties(_ref, ['asyncError', 'blur', 'change', 'focus', 'initial', 'mapProps', 'state', 'submitError', 'submitFailed', 'syncError', 'value', '_value']);

  var defaultValue = arguments.length <= 4 || arguments[4] === undefined ? '' : arguments[4];
  var asyncValidate = arguments.length <= 5 || arguments[5] === undefined ? _lodash4.default : arguments[5];

  var error = syncError || asyncError || submitError;
  var onChange = (0, _createOnChange2.default)(change);
  var initialValue = initial || initialPropValue;
  var props = processProps(_extends({
    active: state && !!getIn(state, 'active'),
    dirty: value !== initialValue,
    error: error,
    invalid: !!error,
    name: name,
    onBlur: (0, _createOnBlur2.default)(blur, (0, _lodash2.default)(asyncValidate, name)),
    onChange: onChange,
    onDragStart: (0, _createOnDragStart2.default)(name, value),
    onDrop: (0, _createOnDrop2.default)(name, change),
    onFocus: (0, _createOnFocus2.default)(name, focus),
    onUpdate: onChange,
    pristine: value === initialValue,
    touched: !!(state && getIn(state, 'touched') || submitFailed),
    valid: !error,
    value: value === undefined ? defaultValue : value,
    visited: state && !!getIn(state, 'visited')
  }, rest), _value);
  var mappedProps = mapProps ? mapProps(props) : {};
  return _extends({}, props, mappedProps);
};

exports.default = createFieldProps;