'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var createDeleteInWithCleanUp = function createDeleteInWithCleanUp(_ref) {
  var deepEqual = _ref.deepEqual;
  var empty = _ref.empty;
  var getIn = _ref.getIn;
  var deleteIn = _ref.deleteIn;


  var deleteInWithCleanUp = function deleteInWithCleanUp(state, path) {
    var result = deleteIn(state, path);
    var dotIndex = path.lastIndexOf('.');
    if (dotIndex > 0) {
      var parentPath = path.substring(0, dotIndex);
      var parent = getIn(result, parentPath);
      if (deepEqual(parent, empty)) {
        return deleteInWithCleanUp(result, parentPath);
      }
    }
    return result;
  };

  return deleteInWithCleanUp;
};

exports.default = createDeleteInWithCleanUp;