'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.default = fieldKeys;

var _marked = [generate, fieldKeys].map(regeneratorRuntime.mark);

function generate(field, values) {
  var path = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

  var _$exec, _$exec2, key, rest, noBrackets, array, index, _index;

  return regeneratorRuntime.wrap(function generate$(_context) {
    while (1) {
      switch (_context.prev = _context.next) {
        case 0:
          _$exec = /([^.]+)\.?(.+)?/.exec(field);
          _$exec2 = _slicedToArray(_$exec, 3);
          key = _$exec2[1];
          rest = _$exec2[2];

          if (!/.+\[\]/.test(key)) {
            _context.next = 32;
            break;
          }

          // is array key
          noBrackets = key.substring(0, key.length - 2);
          array = values && values[noBrackets];

          if (!(array && !Array.isArray(array))) {
            _context.next = 9;
            break;
          }

          throw new Error('Expected array value for ' + path + field + ', but found ' + (typeof array === 'undefined' ? 'undefined' : _typeof(array)) + ': ' + JSON.stringify(array));

        case 9:
          if (!array) {
            _context.next = 28;
            break;
          }

          if (!rest) {
            _context.next = 19;
            break;
          }

          _context.t0 = regeneratorRuntime.keys(array);

        case 12:
          if ((_context.t1 = _context.t0()).done) {
            _context.next = 17;
            break;
          }

          index = _context.t1.value;
          return _context.delegateYield(generate(rest, array[index], '' + path + noBrackets + '[' + index + '].'), 't2', 15);

        case 15:
          _context.next = 12;
          break;

        case 17:
          _context.next = 26;
          break;

        case 19:
          _context.t3 = regeneratorRuntime.keys(array);

        case 20:
          if ((_context.t4 = _context.t3()).done) {
            _context.next = 26;
            break;
          }

          _index = _context.t4.value;
          _context.next = 24;
          return '' + path + noBrackets + '[' + _index + ']';

        case 24:
          _context.next = 20;
          break;

        case 26:
          _context.next = 30;
          break;

        case 28:
          _context.next = 30;
          return '' + path + key;

        case 30:
          _context.next = 38;
          break;

        case 32:
          if (!rest) {
            _context.next = 36;
            break;
          }

          return _context.delegateYield(generate(rest, values && values[key], '' + path + key + '.'), 't5', 34);

        case 34:
          _context.next = 38;
          break;

        case 36:
          _context.next = 38;
          return '' + path + key;

        case 38:
        case 'end':
          return _context.stop();
      }
    }
  }, _marked[0], this);
}

/**
 * Iterates over all the fields specified by a fields array and store values.
 *
 * @param fields The fields array given to redux-form
 * @param values The current values of the form in the Redux store
 */
function fieldKeys() {
  var fields = arguments.length <= 0 || arguments[0] === undefined ? [] : arguments[0];
  var values = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, field;

  return regeneratorRuntime.wrap(function fieldKeys$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          _iteratorNormalCompletion = true;
          _didIteratorError = false;
          _iteratorError = undefined;
          _context2.prev = 3;
          _iterator = fields[Symbol.iterator]();

        case 5:
          if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
            _context2.next = 11;
            break;
          }

          field = _step.value;
          return _context2.delegateYield(generate(field, values), 't0', 8);

        case 8:
          _iteratorNormalCompletion = true;
          _context2.next = 5;
          break;

        case 11:
          _context2.next = 17;
          break;

        case 13:
          _context2.prev = 13;
          _context2.t1 = _context2['catch'](3);
          _didIteratorError = true;
          _iteratorError = _context2.t1;

        case 17:
          _context2.prev = 17;
          _context2.prev = 18;

          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }

        case 20:
          _context2.prev = 20;

          if (!_didIteratorError) {
            _context2.next = 23;
            break;
          }

          throw _iteratorError;

        case 23:
          return _context2.finish(20);

        case 24:
          return _context2.finish(17);

        case 25:
        case 'end':
          return _context2.stop();
      }
    }
  }, _marked[1], this, [[3, 13, 17, 25], [18,, 20, 24]]);
}