'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _bindActionData = require('./bindActionData');

var _bindActionData2 = _interopRequireDefault(_bindActionData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getDisplayName = function getDisplayName(Comp) {
  return Comp.displayName || Comp.name || 'Component';
};

var formConnect = function formConnect(mapStateToProps, mapDispatchToProps) {
  return function (WrappedComponent) {
    var FormContextListner = function FormContextListner(props, context) {
      if (!context._reduxForm) {
        throw new Error(getDisplayName(WrappedComponent) + ' must be inside a component decorated with reduxForm()');
      }
      var _context$_reduxForm = context._reduxForm;
      var form = _context$_reduxForm.form;
      var getFormState = _context$_reduxForm.getFormState;

      var ConnectedComponent = (0, _reactRedux.connect)(function (state) {
        return mapStateToProps(getFormState(state));
      }, (0, _bindActionData2.default)(mapDispatchToProps, { form: form }))(WrappedComponent);
      return _react2.default.createElement(ConnectedComponent, props);
    };
    FormContextListner.contextTypes = {
      _reduxForm: _react.PropTypes.object
    };
    return FormContextListner;
  };
};

exports.default = formConnect;