'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isPromise = require('is-promise');

var _isPromise2 = _interopRequireDefault(_isPromise);

var _SubmissionError = require('./SubmissionError');

var _SubmissionError2 = _interopRequireDefault(_SubmissionError);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var handleSubmit = function handleSubmit(submit, props, isValid, asyncValidate) {
  var dispatch = props.dispatch;
  var startSubmit = props.startSubmit;
  var stopSubmit = props.stopSubmit;
  var submitFailed = props.submitFailed;
  var syncErrors = props.syncErrors;
  var returnRejectedSubmitPromise = props.returnRejectedSubmitPromise;
  var values = props.values;


  if (isValid) {
    var doSubmit = function doSubmit() {
      var result = submit(values, dispatch);
      if ((0, _isPromise2.default)(result)) {
        startSubmit();
        return result.then(function (submitResult) {
          stopSubmit();
          return submitResult;
        }).catch(function (submitError) {
          stopSubmit(submitError instanceof _SubmissionError2.default ? submitError.errors : undefined);
          if (returnRejectedSubmitPromise) {
            return Promise.reject(submitError);
          }
        });
      }
      return result;
    };

    return asyncValidate ? asyncValidate().then(doSubmit, function (asyncErrors) {
      submitFailed();
      if (returnRejectedSubmitPromise) {
        return Promise.reject(asyncErrors);
      }
    }) : doSubmit();
  } else {
    submitFailed();

    if (returnRejectedSubmitPromise) {
      return Promise.reject(syncErrors);
    }
  }
};

exports.default = handleSubmit;