'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _lodash = require('lodash.every');

var _lodash2 = _interopRequireDefault(_lodash);

var _actions = require('./actions');

var importedActions = _interopRequireWildcard(_actions);

var _bindActionData = require('./bindActionData');

var _bindActionData2 = _interopRequireDefault(_bindActionData);

var _handleSubmit = require('./handleSubmit');

var _handleSubmit2 = _interopRequireDefault(_handleSubmit);

var _silenceEvent = require('./events/silenceEvent');

var _silenceEvent2 = _interopRequireDefault(_silenceEvent);

var _silenceEvents = require('./events/silenceEvents');

var _silenceEvents2 = _interopRequireDefault(_silenceEvents);

var _asyncValidation = require('./asyncValidation');

var _asyncValidation2 = _interopRequireDefault(_asyncValidation);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var blur = importedActions.blur;
var change = importedActions.change;
var focus = importedActions.focus;
var setSyncValidationErrors = importedActions.setSyncValidationErrors;

var formActions = _objectWithoutProperties(importedActions, ['blur', 'change', 'focus', 'setSyncValidationErrors']);

var getDisplayName = function getDisplayName(Comp) {
  return Comp.displayName || Comp.name || 'Component';
};
var propsToUpdateFor = ['asyncValidating', 'dirty', 'error', 'invalid', 'pristine', 'submitting', 'valid'];

/**
 * The decorator that is the main API to redux-form
 */
var createReduxForm = function createReduxForm(structure) {
  var deepEqual = structure.deepEqual;
  var empty = structure.empty;
  var getIn = structure.getIn;
  var setIn = structure.setIn;
  var fromJS = structure.fromJS;

  return function (initialConfig) {
    var config = _extends({
      touchOnBlur: true,
      touchOnChange: false,
      destroyOnUnmount: true,
      getFormState: function getFormState(state) {
        return getIn(state, 'form');
      }
    }, initialConfig);
    return function (WrappedComponent) {
      var Form = function (_Component) {
        _inherits(Form, _Component);

        function Form(props) {
          _classCallCheck(this, Form);

          var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Form).call(this, props));

          _this.submit = _this.submit.bind(_this);
          _this.asyncValidate = _this.asyncValidate.bind(_this);
          _this.register = _this.register.bind(_this);
          _this.unregister = _this.unregister.bind(_this);
          _this.fields = {};
          return _this;
        }

        _createClass(Form, [{
          key: 'getChildContext',
          value: function getChildContext() {
            var _this2 = this;

            return {
              _reduxForm: _extends({}, this.props, {
                getFormState: function getFormState(state) {
                  return getIn(_this2.props.getFormState(state), _this2.props.form);
                },
                asyncValidate: this.asyncValidate,
                register: this.register,
                unregister: this.unregister
              })
            };
          }
        }, {
          key: 'initIfNeeded',
          value: function initIfNeeded(_ref) {
            var initialize = _ref.initialize;
            var initialized = _ref.initialized;
            var initialValues = _ref.initialValues;

            if (initialValues && !initialized) {
              initialize(initialValues);
            }
          }
        }, {
          key: 'componentWillMount',
          value: function componentWillMount() {
            this.initIfNeeded(this.props);
          }
        }, {
          key: 'componentWillReceiveProps',
          value: function componentWillReceiveProps(nextProps) {
            this.initIfNeeded(nextProps);
          }
        }, {
          key: 'shouldComponentUpdate',
          value: function shouldComponentUpdate(nextProps) {
            var _this3 = this;

            // useful to debug rerenders
            //propsToUpdateFor.forEach(prop => {
            //  if (this.props[ prop ] !== nextProps[ prop ]) {
            //    console.info(prop, 'changed', this.props[ prop ], '==>', nextProps[ prop ])
            //  }
            //})
            return propsToUpdateFor.some(function (prop) {
              return _this3.props[prop] !== nextProps[prop];
            });
          }
        }, {
          key: 'register',
          value: function register(key, field) {
            this.fields[key] = field;
          }
        }, {
          key: 'unregister',
          value: function unregister(key) {
            delete this.fields[key];
          }
        }, {
          key: 'asyncValidate',
          value: function asyncValidate(name, value) {
            var _this4 = this;

            var _props = this.props;
            var asyncBlurFields = _props.asyncBlurFields;
            var asyncValidate = _props.asyncValidate;
            var dispatch = _props.dispatch;
            var initialized = _props.initialized;
            var pristine = _props.pristine;
            var startAsyncValidation = _props.startAsyncValidation;
            var stopAsyncValidation = _props.stopAsyncValidation;
            var syncErrors = _props.syncErrors;
            var values = _props.values;

            var isSubmitting = !name;
            if (asyncValidate) {
              var _ret = function () {
                var valuesToValidate = isSubmitting ? values : setIn(values, name, value);
                var syncValidationPasses = isSubmitting || !getIn(syncErrors, name);
                var isBlurField = !isSubmitting && (!asyncBlurFields || ~asyncBlurFields.indexOf(name));

                // if blur validating, only run async validate if sync validation passes and either no
                // blur fields are passed or the field that has blurred is listed
                // if submitting (not blur validation) or form is dirty or form was never initialized
                if (syncValidationPasses && (isSubmitting || !pristine || !initialized) && (isSubmitting || isBlurField)) {
                  return {
                    v: (0, _asyncValidation2.default)(function () {
                      return asyncValidate(valuesToValidate, dispatch, _this4.props);
                    }, startAsyncValidation, stopAsyncValidation, name)
                  };
                }
              }();

              if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
            }
          }
        }, {
          key: 'submit',
          value: function submit(submitOrEvent) {
            var _this5 = this;

            var onSubmit = this.props.onSubmit;


            var check = function check(submit) {
              if (!submit || typeof submit !== 'function') {
                throw new Error('You must either pass handleSubmit() an onSubmit function or pass onSubmit as a prop');
              }
              return submit;
            };
            return !submitOrEvent || (0, _silenceEvent2.default)(submitOrEvent) ?
            // submitOrEvent is an event: fire submit
            (0, _handleSubmit2.default)(check(onSubmit), this.props, this.valid) :
            // submitOrEvent is the submit function: return deferred submit thunk
            (0, _silenceEvents2.default)(function () {
              return (0, _handleSubmit2.default)(check(submitOrEvent), _this5.props, _this5.valid);
            });
          }
        }, {
          key: 'render',
          value: function render() {
            // remove some redux-form config-only props
            var _props2 = this.props;
            var asyncErrors = _props2.asyncErrors;
            var reduxMountPoint = _props2.reduxMountPoint;
            var destroyOnUnmount = _props2.destroyOnUnmount;
            var form = _props2.form;
            var getFormState = _props2.getFormState;
            var touchOnBlur = _props2.touchOnBlur;
            var touchOnChange = _props2.touchOnChange;
            var syncErrors = _props2.syncErrors;
            var values = _props2.values;

            var passableProps = _objectWithoutProperties(_props2, ['asyncErrors', 'reduxMountPoint', 'destroyOnUnmount', 'form', 'getFormState', 'touchOnBlur', 'touchOnChange', 'syncErrors', 'values']); // eslint-disable-line no-redeclare


            return _react2.default.createElement(WrappedComponent, _extends({}, passableProps, {
              handleSubmit: this.submit
            }));
          }
        }, {
          key: 'values',
          get: function get() {
            return this.props.values;
          }
        }, {
          key: 'valid',
          get: function get() {
            return (0, _lodash2.default)(this.fields, function (field) {
              return field.isValid();
            });
          }
        }, {
          key: 'invalid',
          get: function get() {
            return !this.valid;
          }
        }]);

        return Form;
      }(_react.Component);

      Form.displayName = 'Form(' + getDisplayName(WrappedComponent) + ')';
      Form.WrappedComponent = WrappedComponent;
      Form.childContextTypes = {
        _reduxForm: _react.PropTypes.object.isRequired
      };
      Form.propTypes = {
        destroyOnUnmount: _react.PropTypes.bool,
        form: _react.PropTypes.string.isRequired,
        initialValues: _react.PropTypes.object,
        getFormState: _react.PropTypes.func,
        touchOnBlur: _react.PropTypes.bool,
        touchOnChange: _react.PropTypes.bool
      };

      var connector = (0, _reactRedux.connect)(function (state, _ref2) {
        var form = _ref2.form;
        var getFormState = _ref2.getFormState;
        var initialValues = _ref2.initialValues;

        var formState = getIn(getFormState(state) || empty, form) || empty;
        var stateInitial = getIn(formState, 'initial');
        var initial = initialValues || stateInitial || empty;
        var values = getIn(formState, 'values') || initial || empty;
        var pristine = deepEqual(initial, values);
        var syncErrors = getIn(formState, 'syncErrors');
        var asyncErrors = getIn(formState, 'asyncErrors');
        var hasSyncErrors = syncErrors && !deepEqual(syncErrors, empty);
        var hasAsyncErrors = asyncErrors && !deepEqual(asyncErrors, empty);
        var valid = !(hasSyncErrors || hasAsyncErrors);
        var submitting = !!getIn(formState, 'submitting');
        var error = getIn(formState, 'error');
        return {
          asyncErrors: asyncErrors,
          asyncValidating: getIn(formState, 'asyncValidating'),
          dirty: !pristine,
          error: error,
          initialized: !!stateInitial,
          invalid: !valid,
          pristine: pristine,
          submitting: submitting,
          syncErrors: syncErrors,
          valid: valid,
          values: values
        };
      }, function (dispatch, ownProps) {
        return _extends({}, (0, _redux.bindActionCreators)((0, _bindActionData2.default)(formActions, { form: ownProps.form }), dispatch), (0, _bindActionData2.default)({
          blur: (0, _bindActionData2.default)(blur, {
            touch: !!ownProps.touchOnBlur
          }),
          change: (0, _bindActionData2.default)(change, {
            touch: !!ownProps.touchOnChange
          }),
          focus: focus
        }, { form: ownProps.form }), {
          dispatch: dispatch
        });
      }, undefined, { withRef: true });
      var ConnectedForm = (0, _hoistNonReactStatics2.default)(connector(Form), WrappedComponent);
      ConnectedForm.defaultProps = config;

      // build outer component to expose instance api
      return function (_Component2) {
        _inherits(ReduxForm, _Component2);

        function ReduxForm() {
          _classCallCheck(this, ReduxForm);

          return _possibleConstructorReturn(this, Object.getPrototypeOf(ReduxForm).apply(this, arguments));
        }

        _createClass(ReduxForm, [{
          key: 'submit',
          value: function submit() {
            return this.refs.wrapped.getWrappedInstance().submit();
          }
        }, {
          key: 'render',
          value: function render() {
            var _props3 = this.props;
            var initialValues = _props3.initialValues;

            var rest = _objectWithoutProperties(_props3, ['initialValues']);
            // convert initialValues if need to


            return _react2.default.createElement(ConnectedForm, _extends({ ref: 'wrapped', initialValues: fromJS(initialValues) }, rest));
          }
        }]);

        return ReduxForm;
      }(_react.Component);
    };
  };
};

exports.default = createReduxForm;