'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _index = require('../plain/index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var deepEqual = _index2.default.deepEqual;


var deepEqualValues = function deepEqualValues(a, b) {
  if (_immutable.Iterable.isIterable(a)) {
    if (_immutable.Iterable.isIterable(b)) {
      return a.count() === b.count() && a.every(function (value, key) {
        return deepEqualValues(value, b.get(key));
      });
    }
    return false;
  }
  return deepEqual(a, b); // neither are immutable iterables
};

exports.default = deepEqualValues;