'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _immutable = require('immutable');

var _lodash = require('lodash.topath');

var _lodash2 = _interopRequireDefault(_lodash);

var _deepEqual = require('./deepEqual');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _deleteWithPath = require('./deleteWithPath');

var _deleteWithPath2 = _interopRequireDefault(_deleteWithPath);

var _getIn = require('../plain/getIn');

var _getIn2 = _interopRequireDefault(_getIn);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var structure = {
  empty: (0, _immutable.Map)(),
  getIn: function getIn(state, field) {
    return _immutable.Map.isMap(state) ? state.getIn((0, _lodash2.default)(field)) : (0, _getIn2.default)(state, field);
  },
  setIn: function setIn(state, field, value) {
    return state.setIn((0, _lodash2.default)(field), value);
  },
  deepEqual: _deepEqual2.default,
  deleteIn: function deleteIn(state, field) {
    return state.deleteIn((0, _lodash2.default)(field));
  },
  deleteWithPath: _deleteWithPath2.default,
  fromJS: function fromJS(jsValue) {
    return (0, _immutable.fromJS)(jsValue, function (key, value) {
      return _immutable.Iterable.isIndexed(value) ? value.toList() : value.toMap();
    });
  }
};

exports.default = structure;