'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var isObject = function isObject(value) {
  return value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object';
};

var deleteWithPath = function deleteWithPath(state, matcher) {
  var path = arguments.length <= 2 || arguments[2] === undefined ? '' : arguments[2];

  if (state === undefined) {
    return state;
  }

  if (Array.isArray(state)) {
    var _ret = function () {
      var changed = false;
      var processed = [];
      state.forEach(function (value, index) {
        var nextPath = path ? path + '[' + index + ']' : String(index);
        if (matcher.test(nextPath)) {
          changed = true;
        } else {
          var next = deleteWithPath(value, matcher, nextPath);
          if (next !== value) {
            changed = true;
          }
          processed.push(next);
        }
      });
      return {
        v: changed ? processed : state
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }
  if (isObject(state)) {
    var _ret2 = function () {
      var changed = false;
      var processed = {};
      Object.keys(state).forEach(function (key) {
        var nextPath = path ? path + '.' + key : key;
        if (matcher.test(nextPath)) {
          changed = true;
        } else {
          var next = deleteWithPath(state[key], matcher, nextPath);
          if (next !== state[key]) {
            changed = true;
          }
          processed[key] = next;
        }
      });
      return {
        v: changed ? processed : state
      };
    }();

    if ((typeof _ret2 === 'undefined' ? 'undefined' : _typeof(_ret2)) === "object") return _ret2.v;
  }
  return state;
};

exports.default = deleteWithPath;