'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isObject = function isObject(value) {
  return value && (typeof value === 'undefined' ? 'undefined' : _typeof(value)) === 'object';
};

var expectations = {
  toBeAList: function toBeAList() {
    _expect2.default.assert(Array.isArray(this.actual), 'expected %s to be an array', this.actual);
    return this;
  },
  toBeAMap: function toBeAMap() {
    _expect2.default.assert(isObject(this.actual), 'expected %s to be an object', this.actual);
    return this;
  },
  toBeSize: function toBeSize(size) {
    _expect2.default.assert(this.actual && (Array.isArray(this.actual) ? this.actual : Object.keys(this.actual)).length === size, 'expected %s to contain %s elements', this.actual, size);
    return this;
  },
  toEqualMap: function toEqualMap(expected) {
    return (0, _expect2.default)(this.actual).toEqual(expected);
  }
};

exports.default = expectations;